% rs485dde - DDE-Schnittstelle fr RS485 - haftmann#software, 08/02
%______________________________________________________________________________
%--- Allgemeine Aufrufsyntax: ---
%![pfad\]rs485dde.exe				% Aufruf der .EXE
%
%--- Vorhandene Funktionen und Aufrufsyntax: ---
% kanal=    ddeinit('rs485','com2 9600,n,8,1') 	% Konversations-Start
%           ddeterm(kanal)			% Konversations-Ende
%           ddepoke(kanal,'#01;','text')	% Text schreiben mit Prfsumme
%           ddepoke(kanal,'%01:','text')	% Text schreiben ohne Prfsumme
% ret_text= ddereq(kanal,'#01:>;',[1 1])	% Text lesen mit Prfsumme
% ret_text= ddereq(kanal,'%01:>:',[1 1])	% Text lesen ohne Prfsumme
% ret_text= ddereq(kanal,'#01\r',[1 1]')	% Binr lesen
%
%--- Beispiel (Sensokom 5401): ---
% k=        ddeinit('rs485','com2');		% Kanalhandle ergattern
% disp_text=ddereq(k,'#01:>;',[1 1]);		% Text (dddddddds) holen
%           ddeterm(k);
%
% h#s 08/02
